import 'package:healthrian_ble_interface/healthrian_ble_interface.dart';

class ModuleImpl extends ModuleInterface {
  ModuleBle ble = ModuleBle(
    uuid: UUID(
      characteristicStringMap: {
        Characteristics.LEAD_STATE_ECG: '00002C00-0000-1000-8000-00805F9B34FB',

        /// ONE_CHANNEL
        Characteristics.MEASUREMENT_ECG: '00002C01-0000-1000-8000-00805F9B34FB',
        Characteristics.TAP_BUTTON: '',

        /// RESPIRATION_ONE_CHANNEL
        Characteristics.MEASUREMENT_OXI_STANDBY:
            ' 00002C11-0000-1000-8000-00805F9B34FB',

        /// PULSE_OXIMETER_CONTINUOUS
        Characteristics.MEASUREMENT_OXI: '00002A5F-0000-1000-8000-00805F9B34FB',

        /// PULSE_OXIMETER_CONFIGURATION
        Characteristics.CONFIG_OXI: '00002A60-0000-1000-8000-00805F9B34FB',
        Characteristics.BODY_TEMPERATURE: '',
        Characteristics.CONTROL_POINT: '00002CF0-0000-1000-8000-00805F9B34FB',
        Characteristics.CONTROL_POINT_RESPONSE:
            '00002CF1-0000-1000-8000-00805F9B34FB',
        Characteristics.BATTERY_LEVEL: '00002A19-0000-1000-8000-00805F9B34FB',
        Characteristics.PRODUCT_MANUFACTURER:
            '00002A29-0000-1000-8000-00805F9B34FB',
        Characteristics.FIRMWARE_VERSION:
            '00002A26-0000-1000-8000-00805F9B34FB',
        Characteristics.SERIAL_NUMBER: '00002A25-0000-1000-8000-00805F9B34FB',
      },
      enableEcg: true,
      enableOxi: true,
    ),
    scanFilter: Builtin.scanFilterWearCardioT,
  );

  Commands _commands = Commands(
    ble: CommandsBle(
      firmware: [0xFA],
      setDate: [0x80],
    ),
    ecg: CommandsEcg(
      start: [0x11],
      stop: [0x81],
    ),
    oxi: CommandsOxi(
      start: [0x20],
      stop: [0x90],
    ),
  );

  late ModuleEcg? ecg = ModuleEcg(
    ble: ble,
    commands: _commands,
    udfLeadStream: Builtin.udfLeadStreamCardioClick,
    udfLeadCompute: Builtin.udfLeadComputeWearCardioT,
    udfConvert: Builtin.udfConvertWearCardioT,
    samplingRate: 250,
    channelCount: 1,
    filterCount: 1,
    sampleCount: 60,
  );

  late ModuleOxi? oxi = ModuleOxi(
    ble: ble,
    commands: _commands,
  );
}
